//
//  JSONParser.m
//  MenuMenu
//
//  Created by Pawel Ferens on 12/6/12.
//  Copyright (c) 2012 Pawel Ferens. All rights reserved.
//

#import "JSONParser.h"

@implementation JSONParser
-(NSMutableArray*)fetchDataFromJSONWithData:(NSMutableData*)data
{
    NSMutableArray*resultListOfRestaurants=[[NSMutableArray alloc]init];        //list of all Restaurant objects
    
    NSError* err;
    NSDictionary*dictionary=[NSJSONSerialization
                             JSONObjectWithData:data options:kNilOptions error:&err];
    NSArray*restaurants=[dictionary objectForKey:@"Restaurants"];
//  NSLog(@"%@",restaurants);
    for(int i=0;i<[restaurants count];i++)
    {
        Restaurant*restaurant=[[Restaurant alloc]init];
        NSDictionary*singleRest=[restaurants objectAtIndex:i];
        restaurant.id=[singleRest objectForKey:@"id"];
        restaurant.name=[singleRest objectForKey:@"name"];
        restaurant.address=[singleRest objectForKey:@"address"];
//        restaurant.city=[singleRest objectForKey:@"city"];
//        restaurant.cityId=[singleRest objectForKey:@"cityId"];
        restaurant.district=[singleRest objectForKey:@"district"];
//        restaurant.lng=[singleRest objectForKey:@"lng"];
//        restaurant.lat=[singleRest objectForKey:@"lat"];
//        restaurant.mailRestaurant=[singleRest objectForKey:@"mailRestaurant"];
//        restaurant.phoneRestaurant=[singleRest objectForKey:@"phoneRestaurant"];
//        restaurant.mailUser=[singleRest objectForKey:@"mailUser"];
//        restaurant.phoneUser=[singleRest objectForKey:@"phoneUser"];
//        restaurant.nameUser=[singleRest objectForKey:@"nameUser"];
//        restaurant.surnameUser=[singleRest objectForKey:@"surnameUser"];
        restaurant.publishedImageIndex = @(-1);
        restaurant.isVisibleForApp=[singleRest objectForKey:@"isVisibleForApp"];
        NSLog(@"%@",restaurant.isVisibleForApp);
//        restaurant.clearBoard=[singleRest objectForKey:@"clearBoard"];
        restaurant.progileImages=[[NSMutableArray alloc]init];
        
        NSArray*profileImages=[singleRest objectForKey:@"profileImages"];
        for(int y=0;y<[profileImages count];y++)
        {
            NSDictionary*singleProfileImage=[profileImages objectAtIndex:y];
            Image*profileImage=[[Image alloc]init];
            profileImage.id=[singleProfileImage objectForKey:@"id"];
            profileImage.restId=[singleProfileImage objectForKey:@"restId"];
            profileImage.blobKey=[singleProfileImage objectForKey:@"blobKey"];
            profileImage.dateCreated=[singleProfileImage objectForKey:@"dateCreated"];
            profileImage.imageType=[singleProfileImage objectForKey:@"imageType"];
            profileImage.width=[singleProfileImage objectForKey:@"width"];
            profileImage.height=[singleProfileImage objectForKey:@"height"];
            [restaurant.progileImages addObject:profileImage];
        }
        
        
        restaurant.logoImages=[[NSMutableArray alloc]init];
        
        NSArray*logoImages=[singleRest objectForKey:@"logoImages"];
        for(int y=0;y<[logoImages count];y++)
        {
            NSDictionary*singleLogoImage=[logoImages objectAtIndex:y];
            Image*logoImage=[[Image alloc]init];
            logoImage.id=[singleLogoImage objectForKey:@"id"];
            logoImage.restId=[singleLogoImage objectForKey:@"restId"];
            logoImage.blobKey=[singleLogoImage objectForKey:@"blobKey"];
            logoImage.dateCreated=[singleLogoImage objectForKey:@"dateCreated"];
            logoImage.imageType=[singleLogoImage objectForKey:@"imageType"];
            logoImage.width=[singleLogoImage objectForKey:@"width"];
            logoImage.height=[singleLogoImage objectForKey:@"height"];
            [restaurant.logoImages addObject:logoImage];
        }
        
        restaurant.menuImages=[[NSMutableArray alloc]init];
        
        NSArray*menuImages=[singleRest objectForKey:@"menuImages"];
        restaurant.mainProfileImageString=[singleRest objectForKey:@"mainProfileImageString"];
        //  NSLog(@"%@",restaurant.mainProfileImageString);
        restaurant.mainMenuImageString=[singleRest objectForKey:@"mainMenuImageString"];
        restaurant.mainLogoImageString=[singleRest objectForKey:@"mainLogoImageString"];
        
        
        NSString *blobEnding = [restaurant.mainMenuImageString substringWithRange:NSMakeRange(20, [restaurant.mainMenuImageString length]-20)];

        for(int y=[menuImages count]-1;y>=0;y--)
        {
            NSDictionary*singleMenuImage=[menuImages objectAtIndex:y];
            Image*menuImage=[[Image alloc]init];
            menuImage.id=[singleMenuImage objectForKey:@"id"];
            menuImage.restId=[singleMenuImage objectForKey:@"restId"];
            menuImage.blobKey=[singleMenuImage objectForKey:@"blobKey"];
            if ([menuImage.blobKey isEqualToString:blobEnding]) {
                restaurant.publishedImageIndex = @(menuImages.count - 1 - y);
                NSLog(@"  ustawione  jest zdjecie nr   %d",menuImages.count - 1 - y);               //checking main menu picture, if existing, setting mainNumber variable
            }            
//            NSLog(@"%@",menuImage.blobKey);
            menuImage.dateCreated=[singleMenuImage objectForKey:@"dateCreated"];
            menuImage.imageType=[singleMenuImage objectForKey:@"imageType"];
            menuImage.width=[singleMenuImage objectForKey:@"width"];
            menuImage.height=[singleMenuImage objectForKey:@"height"];
            [restaurant.menuImages addObject:menuImage];
        }

//        NSLog(@"%@",[[restaurant.menuImages objectAtIndex:0]blobKey]);
[resultListOfRestaurants addObject:restaurant];

    }
//NSLog(@"%@",[[[[resultListOfRestaurants objectAtIndex:0]logoImages]objectAtIndex:0]blobKey]);
return resultListOfRestaurants;
}
@end
