//
//  MainViewController.m
//  MenuMenu
//
//  Created by Pawel Ferens on 12/5/12.
//  Copyright (c) 2012 Pawel Ferens. All rights reserved.
//

#import "MainViewController.h"

@interface MainViewController (){
    UIAlertView *loading;
    NSOperationQueue *queue;
    UIActivityIndicatorView *tempSpinner;
}

@end

@implementation MainViewController
@synthesize manager;
@synthesize aSpinner;
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
-(void)showAlertView
{
    [loading dismissWithClickedButtonIndex:1 animated:NO];
    UIAlertView*alertWiev=[[UIAlertView alloc]
                           initWithTitle:NSLocalizedString(@"LOGIN TITLE", nil) message:NSLocalizedString(@"LOGIN MESSAGE", nil) delegate:self cancelButtonTitle:NSLocalizedString(@"LOGIN CLEAR", nil) otherButtonTitles:@"OK", nil];
    [alertWiev setAlertViewStyle:UIAlertViewStyleLoginAndPasswordInput];
    
    NSUserDefaults *prefs = [NSUserDefaults standardUserDefaults];
    NSString *log = [prefs stringForKey:@"login"];
    NSString *pass = [prefs stringForKey:@"password"];
    if (![log isEqualToString:@""]) {
        [[alertWiev textFieldAtIndex:0]setText:log];
        [[alertWiev textFieldAtIndex:1]setText:pass];
    }
    
    [alertWiev show];
   
}


-(void) viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:TRUE];
    [self showAlertView];
    
}

-(void)viewWillAppear:(BOOL)animated{
    if(queue == nil){
        queue = [[NSOperationQueue alloc] init];
        [queue setMaxConcurrentOperationCount:1];
        [queue cancelAllOperations];
    }
}

-(void)alertView:(UIAlertView*)alertView
clickedButtonAtIndex:(NSInteger)buttonIndex
{
    //NSString* buttonTitle=[alertView buttonTitleAtIndex:buttonIndex];
    
    if(alertView.tag == 23){
        if(buttonIndex == 0){
            [manager.connection cancel];
            [tempSpinner stopAnimating];
            if ([[self.navigationController.viewControllers lastObject] isEqual:self]) {
                
                [self showAlertView];
            }
            else{
                [queue cancelAllOperations];
                [self.navigationController popViewControllerAnimated:YES];
            }
        }
    }
    else{
        if(buttonIndex==1)
        {
            
            //int lCurrentWidth = self.view.frame.size.width;
            int lCurrentHeight = self.view.frame.size.height;
            //        tempSpinner = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
            [tempSpinner setCenter:CGPointMake(160, lCurrentHeight/2)];
            tempSpinner.color=[UIColor redColor];
            self.aSpinner = tempSpinner;
            [self.view addSubview:self.aSpinner];
            [self.aSpinner startAnimating];
            
            
            //  _loadingLabel.hidden=FALSE;
            //  [_spinner startAnimating];
            NSString* login= [[alertView textFieldAtIndex:0]text];
            NSString* password=[[alertView textFieldAtIndex:1]text];
            NSLog(@"%@ ,  %@",login,password);
            //getting json with data, after loading             method useNotificationWithStringIsCalled
            
            if ([login isEqualToString:@""]| [password isEqualToString:@""]) {
                // _loadingLabel.hidden=TRUE;
                [self.aSpinner stopAnimating];
                [self showAlertView];
            }
            else
            {
                [self getDataForLogin: login andPassword: password];
            }
            
        }
        else if (buttonIndex==0)
        {
            NSUserDefaults*prefs=[NSUserDefaults standardUserDefaults];
            [prefs setObject:@"" forKey:@"login"];
            [prefs setObject:@"" forKey:@"password"];
            [self showAlertView];
        }
    }
    
}

-(void)getDataForLogin: (NSString*)login andPassword: (NSString*)password{
    
    NSUserDefaults *prefs = [NSUserDefaults standardUserDefaults];
    [prefs setObject:login forKey:@"login"];
    [prefs setObject:password forKey:@"password"];
    
    loading=[[UIAlertView alloc] initWithTitle:NSLocalizedString(@"LOADING", nil)
                                       message:nil
                                      delegate:self
                             cancelButtonTitle:NSLocalizedString(@"CANCEL", nil)
                             otherButtonTitles:nil];
    loading.tag = 23;
    [loading show];
    
    
    [manager loadAvaibleRestaurantsWithLogin:login andPassword:password];
    

}

-(void)hidePopUp{
    //loading
}

-(void)showLoadingIndicator
{
    int lCurrentWidth = self.view.frame.size.width;
    int lCurrentHeight = self.view.frame.size.height;
    _spinner = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    [_spinner setCenter:CGPointMake(lCurrentWidth, lCurrentHeight)]; // I do this because I'm in landscape mode
    _spinner.hidden=FALSE;
    [self.view addSubview:_spinner];
}
- (void)viewDidLoad
{
    [super viewDidLoad];
    
     tempSpinner = [[UIActivityIndicatorView alloc]  initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    
    UILabel *label = [[UILabel alloc] initWithFrame:CGRectZero];
    label.backgroundColor = [UIColor clearColor];
    label.font = [UIFont boldSystemFontOfSize:18.0];
    label.shadowColor = [UIColor colorWithWhite:0.0 alpha:0.5];
    label.textAlignment = UITextAlignmentCenter;
    label.textColor = [UIColor whiteColor]; // change this color
    self.navigationItem.titleView = label;
    label.text = (@"Menu Photo");
    [label sizeToFit];
    
    
    //  _loadingLabel.hidden=TRUE;
    [self.aSpinner stopAnimating];
    UIColor*gray=[UIColor grayColor];
    self.navigationController.navigationBar.tintColor=gray;
    // [self.navigationController.navigationBar setHidden:TRUE ];                            //nav controller hidden
    //   [self showLoadingIndicator];
    _controler = [self.storyboard instantiateViewControllerWithIdentifier:@"list"];
	// settin notification listener
    manager=[[ConnectionManager alloc]init];
    
    NSString *notificationName = @"MTPostNotificationTut";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(useNotificationWithString:)
     name:notificationName
     object:nil];
    
    NSString *notificationNamee = @"restaurantsDownloaded";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(hidePopUp)
     name:notificationNamee
     object:nil];
    
    
    UIBarButtonItem *backButton = [[UIBarButtonItem alloc] initWithTitle:NSLocalizedString(@"LOGOUT", nil) style:UIBarButtonItemStyleBordered target:nil action:nil];
    [[self navigationItem] setBackBarButtonItem:backButton];
    
    UIImageView*bar=[[UIImageView alloc]initWithFrame:CGRectMake(0, 0, 320, 4)];
    [bar setImage:[UIImage imageNamed:@"red_bar"]];
    [self.navigationController.navigationBar addSubview:bar];
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}

- (void)useNotificationWithString:(NSNotification *)notification //use notification method and logic
{
    NSString *key = @"login";
    NSDictionary *dictionary = [notification userInfo];
    NSString *stringValueToUse = [dictionary valueForKey:key];
    NSLog(@"isOK ?? --> %@",stringValueToUse);
    if([stringValueToUse isEqualToString:@"accessDenied"])
    {
        [self showAlertView];
    }
    else
    {
        JSONParser*parser=[[JSONParser alloc]init];
        
        NSBlockOperation* theOp = [NSBlockOperation blockOperationWithBlock: ^{
            [self appdelegate].restaurants = [parser fetchDataFromJSONWithData:manager.responseData];
        }];
        NSBlockOperation* goBlockOp = [NSBlockOperation blockOperationWithBlock: ^{
            [self.navigationController pushViewController:_controler animated:YES]; //save login and password to prefs
            [loading dismissWithClickedButtonIndex:1 animated:YES];
            NSLog(@"dismissed");
        }];
        
        [queue addOperation:theOp];
        [queue addOperation:goBlockOp];
    }
    [self.aSpinner stopAnimating];
}

@end
