//
//  ScrollViewController.m
//  MenuMenu
//
//  Created by Pawel Ferens on 12/5/12.
//  Copyright (c) 2012 Pawel Ferens. All rights reserved.
//

#import "ScrollViewController.h"


@interface ScrollViewController (){
    UIActivityIndicatorView *spinner;
    NSOperationQueue *queue;
    bool isQueueCancelled;
}

@end

@implementation ScrollViewController

@synthesize photos;
@synthesize restaurant;
@synthesize mainMenuImage;
@synthesize xOrigin;
@synthesize responseData;
@synthesize actualLoadedPhoto;
@synthesize loading;
@synthesize ref;
@synthesize buttons;
@synthesize tempButton;
//@synthesize mainNumber;
@synthesize restaurantPhoto;
@synthesize dates;
@synthesize isRefreshing;
@synthesize connection;
@synthesize restaurantIndexAtList;

//protocol methods

-(void)receiveImage:(UIImage*)image{
    [self uploadImageWithImage:image];
}

//-----------------



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

-(void) viewWillDisappear:(BOOL)animated{
   
    [queue cancelAllOperations];
    isQueueCancelled = YES;
     NSLog(@"will returned");
    [loading dismissWithClickedButtonIndex:0 animated:NO];
}

-(void)viewWillAppear:(BOOL)animated{
    NSLog(@"will appear");


}

-(void) viewDidAppear:(BOOL)animated
{
 
    [super viewDidAppear:animated];
    if(![self appdelegate].isRestaurantLoaded){
        [self refreshRestaurant];
        [self appdelegate].isRestaurantLoaded = YES;
    }
    
    UILabel *label = [[UILabel alloc] initWithFrame:CGRectZero];
    label.backgroundColor = [UIColor clearColor];
    label.font = [UIFont boldSystemFontOfSize:14.0];
    label.shadowColor = [UIColor colorWithWhite:0.0 alpha:0.5];
    label.textAlignment = UITextAlignmentCenter;
    label.textColor = [UIColor whiteColor]; // change this color
    self.navigationItem.titleView = label;
    label.text = NSLocalizedString(@"YOUR PROFILE", nil);
    [label sizeToFit];
    _nameOfRestaurant.text=restaurant.name;
    _addressOfRestaurant.text=restaurant.address;

    
}




-(void)updateRestaurant:(NSNotification *)notification{

        isQueueCancelled = NO;
        photos=[[NSMutableArray alloc]init];
        dates=[[NSMutableArray alloc]init];

        NSString*blobEnding2=restaurant.mainLogoImageString;
        blobEnding2 = [blobEnding2 substringWithRange:NSMakeRange(20, [blobEnding2 length]-20)];
        NSString*linkToImage=[NSString stringWithFormat:@"http://menumenu-cms.appspot.com/blobServe?blob-key=%@",blobEnding2];
        
        NSURL *url1 = [NSURL URLWithString:linkToImage];
        NSData *data1 = [NSData dataWithContentsOfURL:url1];
        restaurantPhoto= [[UIImage alloc] initWithData:data1 ];
    
        NSLog(@"%@",linkToImage);
        [queue waitUntilAllOperationsAreFinished];

        for(int i=0;i<[restaurant.menuImages count];i++){
        
            NSBlockOperation* theOp = [NSBlockOperation blockOperationWithBlock: ^{
                if (![theOp isCancelled]) {                    
                    NSString*blobKey=[[restaurant.menuImages objectAtIndex:i]blobKey];                                                  //loading images
                    NSString*final=[NSString stringWithFormat:@"http://menumenu-cms.appspot.com/blobServe?blob-key=%@",blobKey];
                    NSURL *url = [NSURL URLWithString:final];
                    NSData *data = [NSData dataWithContentsOfURL:url];
                    UIImage *img = [[UIImage alloc] initWithData:data ];
                    
                    if (img
                        && ![theOp isCancelled]
                        && i < restaurant.menuImages.count) {
                        
                        Image*ir=[restaurant.menuImages objectAtIndex:i];
                        [photos addObject:img];
                        if( ![theOp isCancelled]){
                            if (ir.dateCreated ) {
                                [dates addObject:ir.dateCreated];
                            }
                            else{
                                [dates addObject:[NSString stringWithFormat:@"%d",i+1]];
                            }
                            NSLog(@"operation %d completed", i);
                        }
                         
                    }
                   
                }
                
            }];
            NSLog(@"queue cancelled: %d", isQueueCancelled);
            if (!isQueueCancelled) {
                [queue addOperation:theOp];
                NSLog(@" op count %d", [queue operationCount]);
            }
            else{
                return;
            }
        }
    
    NSBlockOperation* refreshOp = [[NSBlockOperation alloc]init];
    refreshOp = [NSBlockOperation blockOperationWithBlock: ^{
        if (![refreshOp isCancelled]) {
            [[NSOperationQueue mainQueue] addOperationWithBlock:^{
                if (![refreshOp isCancelled]) {
                    [self reloadScroll];
                    NSLog(@"spr %@",restaurant.isVisibleForApp);
                    //reloading scroll and hiding loading alert
                    [loading dismissWithClickedButtonIndex:0 animated:YES];
                }
            }];
        }
        

    }];
    
    [queue addOperation:refreshOp];
    
                                   
    //[self appdelegate].isLoadingData=NO;
}
-(void)settingImageWentGood:(NSNotification *)notification{
    [spinner stopAnimating];
    spinner.hidden=YES;
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"SUCCESS", nil) message:NSLocalizedString(@"CHANGING PICTURE DONE", nil) delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
    
   // [self appdelegate].isLoadingData=NO;
    
}


-(void)changingVisibilitySuccess:(NSNotification *)notification{
    NSString *key = @"isCorrect";
    NSDictionary *dictionary = [notification userInfo];
    NSString *stringValueToUse = [dictionary valueForKey:key];
    if ([stringValueToUse isEqualToString:@"success"]) {
        NSString*type=restaurant.isVisibleForApp;
        int ok=[type intValue];
        [spinner stopAnimating];
        spinner.hidden=YES;
        if (ok==1) {
            [_isProfilePublihedText setTitle:NSLocalizedString(@"PROFILE IS NOT PUBLISHED", nil) forState:UIControlStateNormal];
            [_isProfilePublishedImage setImage:[UIImage imageNamed:@"wr.png"]];
            restaurant.isVisibleForApp=@"0";
            [_isProfilePublihedText setUserInteractionEnabled:TRUE ];
        }
        else{
            [_isProfilePublihedText setTitle:NSLocalizedString(@"PROFILE IS PUBLISHED", nil) forState:UIControlStateNormal];
            [_isProfilePublishedImage setImage:[UIImage imageNamed:@"confirme.png"]];
            restaurant.isVisibleForApp=@"1";
            [_isProfilePublihedText setUserInteractionEnabled:TRUE ];
        }
    }
    else{
         [_isProfilePublihedText setUserInteractionEnabled:TRUE ];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"ERROR", nil) message:NSLocalizedString(@"CHECK CONNECTION", nil) delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [alert show];
        NSLog(@"%@",restaurant.id);
    }
   
//    [self appdelegate].isLoadingData=NO;
}


- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}

-(void)showBusyPopup
{
//    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"" message:NSLocalizedString(@"BUSY", nil) delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
//    [alert show];
}
-(void)refreshingCompleted:(NSNotification *)notification{                  //function runs when RestaurantRefresher object finish loading data
    NSMutableData *newRest=ref.responseData;
    if(newRest==nil){
        [self refreshRestaurant];
        NSLog(@"refreshed again !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
    }
    else{
        restaurant=[[Restaurant alloc]init];
        
        NSError*err;
        NSDictionary*dictionary=[NSJSONSerialization
                                 JSONObjectWithData:newRest options:kNilOptions error:&err];                //parsing data
        NSDictionary*dictionary2=[dictionary objectForKey:@"Restaurants"];
        restaurant.id=[dictionary2 objectForKey:@"id"];
        restaurant.name=[dictionary2 objectForKey:@"name"];
        restaurant.address=[dictionary2 objectForKey:@"address"];
        restaurant.district=[dictionary2 objectForKey:@"district"];
        restaurant.isVisibleForApp=[dictionary2 objectForKey:@"isVisibleForApp"];
        restaurant.progileImages=[[NSMutableArray alloc]init];
        restaurant.mainMenuImageString=[dictionary2 objectForKey:@"mainMenuImageString"];
        restaurant.publishedImageIndex = @(-1);
        
        NSArray*profileImages=[dictionary2 objectForKey:@"profileImages"];
        for(int y=0;y<[profileImages count];y++)
        {
            NSDictionary*singleProfileImage=[profileImages objectAtIndex:y];
            Image*profileImage=[[Image alloc]init];
            profileImage.id=[singleProfileImage objectForKey:@"id"];
            profileImage.restId=[singleProfileImage objectForKey:@"restId"];
            profileImage.blobKey=[singleProfileImage objectForKey:@"blobKey"];
            profileImage.dateCreated=[singleProfileImage objectForKey:@"dateCreated"];
            profileImage.imageType=[singleProfileImage objectForKey:@"imageType"];
            profileImage.width=[singleProfileImage objectForKey:@"width"];
            profileImage.height=[singleProfileImage objectForKey:@"height"];
            [restaurant.progileImages addObject:profileImage];

        }
        
        
        restaurant.logoImages=[[NSMutableArray alloc]init];
        
        NSArray*logoImages=[dictionary2 objectForKey:@"logoImages"];
        for(int y=0;y<[logoImages count];y++)
        {
            NSDictionary*singleLogoImage=[logoImages objectAtIndex:y];
            Image*logoImage=[[Image alloc]init];
            logoImage.id=[singleLogoImage objectForKey:@"id"];
            logoImage.restId=[singleLogoImage objectForKey:@"restId"];
            logoImage.blobKey=[singleLogoImage objectForKey:@"blobKey"];
            logoImage.dateCreated=[singleLogoImage objectForKey:@"dateCreated"];
            logoImage.imageType=[singleLogoImage objectForKey:@"imageType"];
            logoImage.width=[singleLogoImage objectForKey:@"width"];
            logoImage.height=[singleLogoImage objectForKey:@"height"];
            [restaurant.logoImages addObject:logoImage];
        }
        
        restaurant.menuImages=[[NSMutableArray alloc]init];
        
        NSArray*menuImages=[dictionary2 objectForKey:@"menuImages"];
        NSString *blobEnding = [restaurant.mainMenuImageString substringWithRange:NSMakeRange(20, [restaurant.mainMenuImageString length]-20)];
        

        for(int y=[menuImages count]-1;y>=0;y--)
            // for(int y=0;y<[menuImages count];y++)
        {
            NSDictionary*singleMenuImage=[menuImages objectAtIndex:y];
            Image*menuImage=[[Image alloc]init];
            menuImage.id=[singleMenuImage objectForKey:@"id"];
            menuImage.restId=[singleMenuImage objectForKey:@"restId"];
            menuImage.blobKey=[singleMenuImage objectForKey:@"blobKey"];
            if ([menuImage.blobKey isEqualToString:blobEnding]) {
                restaurant.publishedImageIndex = @(menuImages.count - 1 - y);
                NSLog(@"  ustawione  jest zdjecie nr   %d",menuImages.count - 1 - y);               //checking main menu picture, if existing, setting mainNumber variable
            }
            menuImage.dateCreated=[singleMenuImage objectForKey:@"dateCreated"];
            menuImage.imageType=[singleMenuImage objectForKey:@"imageType"];
            menuImage.width=[singleMenuImage objectForKey:@"width"];
            menuImage.height=[singleMenuImage objectForKey:@"height"];
            [restaurant.menuImages addObject:menuImage];
        }
        restaurant.mainMenuImageString=[dictionary2 objectForKey:@"mainMenuImageString"];
        restaurant.mainLogoImageString=[dictionary2 objectForKey:@"mainLogoImageString"];
        NSLog(@"%@",restaurant.mainMenuImageString);
        
        
        NSString *notificationName = @"updated";
        // [self appdelegate].isLoadingData=NO;
        
        [[NSNotificationCenter defaultCenter] postNotificationName:notificationName object:nil userInfo:nil];           //sending notification when restaurant is refreshed
        
        [[self appdelegate].restaurants replaceObjectAtIndex:restaurantIndexAtList withObject:restaurant];
    }
}

- (void)viewDidLoad
{
    [super viewDidLoad];
 
    queue = [[NSOperationQueue alloc] init];
    [queue setMaxConcurrentOperationCount:1];
    
    spinner = [[UIActivityIndicatorView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height)];
    [spinner setActivityIndicatorViewStyle:UIActivityIndicatorViewStyleWhiteLarge];
    [spinner setBackgroundColor:[UIColor colorWithWhite:0 alpha:0.8f]];
    [spinner setColor:[UIColor colorWithRed: (255/255.0f) green:(10/255.0f) blue:(10/255.0f) alpha:1]];
    [self.view addSubview: spinner];
    [self.view bringSubviewToFront:spinner];
    
    [[_progressBar viewWithTag:0]setCenter:CGPointMake(self.view.frame.size.width/2-20, 50)];
    
    NSString *notificationName = @"updated";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(updateRestaurant:)
     name:notificationName
     object:nil];
    
    
    NSString *notificationNamee = @"changeProfile";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(settingImageWentGood:)
     name:notificationNamee
     object:nil];
    
    NSString *notificationNameee = @"isVisibilityChanged";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(changingVisibilitySuccess:)
     name:notificationNameee
     object:nil];
    
    
    
    NSString *notificationName2 = @"restRefreshed";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(refreshingCompleted:)
     name:notificationName2
     object:nil];
    
    self.navigationItem.rightBarButtonItem=
    [[UIBarButtonItem alloc]initWithTitle:NSLocalizedString(@"REFRESH", nil) style:UIBarButtonItemStylePlain target:self action:@selector(refreshButton:)];
    UIImage*refi=[UIImage imageNamed:@"refresh.png"];                                       //setting graphics to refresh button
    [_test setBackgroundImage:refi forState:UIControlStateNormal];
}

-(void) refreshRestaurant
{
    [self showLoadingPopUp];
    [queue cancelAllOperations];
    isQueueCancelled = YES;
    ref=[[RestaurantRefresher alloc]init];                            //putting data into RestaurantRefresher.responseData object
    [ref refreshRestaurantWithId:restaurant.id];
    NSLog(@"ref ok");
//    }
    
}
-(void) loadImages                                                      //for now this function is never used
{
    photos=[[NSMutableArray alloc]init];
    for(int i=0;i<[restaurant.menuImages count];i++)
    {
        NSString*blobKey=[[restaurant.menuImages objectAtIndex:i]blobKey];
        NSString*final=[NSString stringWithFormat:@"http://menumenu-cms.appspot.com/blobServe?blob-key=%@",blobKey];
        NSLog(@"<><><><><><><><><><><><><>blob %@",blobKey);
        NSURL *url = [NSURL URLWithString:final];
        NSData *data = [NSData dataWithContentsOfURL:url];
        UIImage *img = [[UIImage alloc] initWithData:data ];
        
        [photos addObject:img];
        
    }
    [self reloadScroll];
}
-(void)reloadScroll
{
    NSArray *viewsToRemove = [_scrollView subviews];
    for (UIView *v in viewsToRemove) [v removeFromSuperview];                   //removing all subviews from scrollView
    UIImage*empty=[UIImage imageNamed:@"klisza_piktogram_knajpa.png"];
    xOrigin=0;                                                                  //setting variable used to place images on scrollView to 0
    // Now create a UIScrollView to hold the UIImageViews
    _scrollView = [[UIScrollView alloc] initWithFrame:CGRectMake(0,119,self.view.frame.size.width,200)];            //creating scrollView object
    [_scrollView setTag:99];
    buttons=[[NSMutableArray alloc]init];
    _scrollView.backgroundColor=[UIColor clearColor];
    [_imageViewMainPicture setImage:restaurantPhoto];
    
    int numberOfViews = 30;                                                                 //number of avaible pictures for each restaurant
	for (int i = 0; i < numberOfViews; i++) {
        
        xOrigin = i * 120 +20*(i+1) ;                                                      //calculating position of next image
        UIButton*b=[[UIButton alloc]initWithFrame:CGRectMake(xOrigin,20,120,140)];
        UILabel*date=[[UILabel alloc]initWithFrame:CGRectMake(xOrigin, 10, 120, 10) ];
        date.backgroundColor=[UIColor clearColor];
        date.font = [UIFont boldSystemFontOfSize:8.0];
        date.textAlignment = UITextAlignmentCenter;
        date.textColor=[UIColor redColor];
        b.tag=i+1;                                                                            //setting tag for each button, needed in setMainImage servlet
        if(i< [photos count])
        {
            NSString*toConvert;
            if ([dates objectAtIndex:i]) {
                toConvert=[dates objectAtIndex:i];
                if ([toConvert length]<3) {
                    ;
                }
                else
                {
                    //NSLog(@">>%@",toConvert);
                toConvert = [toConvert substringWithRange:NSMakeRange(0, 6)];
                }
            }
            else
            {
                toConvert=[NSString stringWithFormat:@"%d",i];
            }
            
            
            
            b.imageView.contentMode = UIViewContentModeCenter;
            if ([[photos objectAtIndex:i]size].height>[[photos objectAtIndex:i]size].width) {                       //resizing images to fit button
                UIImage*resized=[self imageWithImageScaledToHeight:[photos objectAtIndex:i] scaledToHeigth:140];
                [b setImage:resized forState:UIControlStateNormal];
                date.text=toConvert;
            }
            else
            {
                UIImage*resized=[self imageWithImage:[photos objectAtIndex:i] scaledToWidth:120];
                [b setImage:resized forState:UIControlStateNormal];
                date.text=toConvert;
            }
            
        }
        else
        {
            [b setBackgroundImage:empty forState:UIControlStateNormal];
            date.text=[NSString stringWithFormat:@"%i",i+1];
        }
        
        [b addTarget:self action:@selector(uploadImage:) forControlEvents:UIControlEventTouchUpInside];
        [buttons addObject:b];
		[_scrollView addSubview:b];
        [_scrollView addSubview:date];
        if (restaurant.publishedImageIndex.intValue==i && i<restaurant.menuImages.count) {
            UIButton*but=(UIButton*)[_scrollView viewWithTag:i+1];
            NSLog(@"loaded pII: %d // %d", i, restaurant.publishedImageIndex.intValue);
            [[but layer] setBorderColor:[[UIColor greenColor] CGColor]];
            [[but layer] setBorderWidth:4.0f];
            [[but layer] setCornerRadius:8.0f];
        }
        if (restaurant.publishedImageIndex.intValue<31) {
            int offset = restaurant.publishedImageIndex.intValue;
            if (offset < 0) offset = 0;
            
            int temporary=offset * 120 +20 * offset;
            [_scrollView setContentOffset:CGPointMake(temporary,0) animated:YES];
        }
	}
    
	_scrollView.contentSize = CGSizeMake(numberOfViews * 120+620, 140);
    
    
	[self checkIsProfilePublished];
    [self.view addSubview:_scrollView];
    [self.view bringSubviewToFront:spinner]; 
}
-(void)uploadImage:(id)selector
{
//    if ([self appdelegate].isLoadingData) {
//        [self showBusyPopup];
//    }
//    else
//    {
        NSLog(@" selector tag = %i",[selector tag]);
//        [self appdelegate].isLoadingData=YES;
        if([selector tag]-1<[photos count])
        {
            CustomAlertView *alert = [[CustomAlertView alloc] initWithTitle:NSLocalizedString(@"CONFIRM", nil)
                                                            message:NSLocalizedString(@"CONFIRM_PROFILE_IMAGE_CHANGE", nil)
                                                           delegate:self
                                                  cancelButtonTitle:NSLocalizedString(@"NO",nil)
                                                  otherButtonTitles:NSLocalizedString(@"YES",nil), nil];
            alert.tag = 22;
            alert.object = selector;
            [alert show];
            
        }
        else
        {
            
            UIActionSheet *pickerPopupChooser = [[UIActionSheet alloc]
                                                 initWithTitle:NSLocalizedString(@"CHOOSE IMAGE", nil)
                                                 delegate:self
                                                 cancelButtonTitle:NSLocalizedString(@"CANCEL", nil)
                                                 destructiveButtonTitle:nil
                                                 otherButtonTitles: NSLocalizedString(@"CHOOSE FROM CAMERA ROLL", nil), NSLocalizedString(@"USE CAMERA", nil), nil];
            
            pickerPopupChooser.actionSheetStyle = UIActionSheetStyleBlackOpaque;
            [pickerPopupChooser showInView:self.view];
           NSLog(@"dodaj plik");
            
        }
//    }
}
-(void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
    UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
    switch (buttonIndex) {
        case 1:
            [imagePicker setSourceType:UIImagePickerControllerSourceTypeCamera];
            [imagePicker setDelegate:self];
            [self presentModalViewController:imagePicker animated:YES];
            break;
        case 0:
            [imagePicker setSourceType:UIImagePickerControllerSourceTypePhotoLibrary];
            [imagePicker setDelegate:self];
            [self presentModalViewController:imagePicker animated:YES];
            
        default:
            break;
    }
}

-(void)checkIsProfilePublished
{
    NSString*type=restaurant.isVisibleForApp;
    int ok=[type intValue];
    if(ok==1)
    {
        [_isProfilePublihedText setTitle:NSLocalizedString(@"PROFILE IS PUBLISHED", nil) forState:UIControlStateNormal];
        //   [_isProfilePublihedText setTitle:@"Change state" forState:UIControlStateHighlighted];
        [_isProfilePublishedImage setImage:[UIImage imageNamed:@"confirme.png"]];
    }
    else
    {
        [_isProfilePublihedText setTitle:NSLocalizedString(@"PROFILE IS NOT PUBLISHED", nil) forState:UIControlStateNormal];
        // [_isProfilePublihedText setTitle:@"Change state" forState:UIControlStateHighlighted];
        [_isProfilePublishedImage setImage:[UIImage imageNamed:@"wr.png"]];
        
    }
}



- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if(alertView.tag == 21){
        if (buttonIndex == 1) {
            spinner.hidden=NO;
            [spinner startAnimating];
            [self changePublishingState];
        }
    }
    else if(alertView.tag == 22){
        CustomAlertView *alertV= (CustomAlertView*)alertView;
        if (buttonIndex == 1) {
            spinner.hidden=NO;
            [spinner startAnimating];
            [self changeProfileImage: alertV.object];
        }
    }
    else if(alertView.tag == 23){
        if(buttonIndex == 0){
            [queue cancelAllOperations];
            isQueueCancelled = YES;
            [self.navigationController popViewControllerAnimated:YES];
        }
    }
    
    else{
        NSLog(@"cancel");
        [connection cancel];
//        [self appdelegate].isLoadingData=NO;
    }
}
-(void)uploadImageWithImage:(UIImage*)image             //main function to upload images to server
{
    
    _alertUpload = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"UPLOADING", nil)
                                              message:NSLocalizedString(@"", nil)
                                             delegate:self
                                    cancelButtonTitle:NSLocalizedString(@"CANCEL",nil)
                                    otherButtonTitles:nil];
   
    [_progressBar setAlpha:1.0f];
    [_progressBar setProgress:0.0f];
    [_alertUpload addSubview:_progressBar];
    [_alertUpload show];
    
    
    UIImage*meg=image;
    
    meg=[self imageWithImage:meg scaledToWidth:880];
    actualLoadedPhoto=meg;//resize obrazu
    NSData *imageData = [[NSData alloc] initWithData:UIImageJPEGRepresentation((meg), 1.0)];
    
    int imageSize = imageData.length;
    //  NSLog(@"%d",imageSize);
    NSString*final=[NSString stringWithFormat:@"http://menumenu-cms.appspot.com/fileUploadServer?token=a1b2c3&imageLenght=%d&imageType=MENU&restaurantId=%@&filename=iOS",imageSize,restaurant.id];
    NSURL*url=[NSURL URLWithString:final];
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
    [request setHTTPMethod:@"POST"];
    
    NSString *boundary = @"0x0hHai1CanHazB0undar135";
    NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@", boundary];
    [request setValue:contentType forHTTPHeaderField:@"Content-Type"];
    
    NSMutableData *body = [NSMutableData data];
    [body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding: NSUTF8StringEncoding]];
    [body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"imageToAttach\"; filename=\"%@\"\r\n",@"meg.jpg"]dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:[[NSString stringWithFormat:@"Content-Type: image/jpeg\r\n\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:imageData];
    [body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
    [request setHTTPBody:body];
    NSLog(@"size of Object: %zd",[request description]);
 
    connection=[[NSURLConnection alloc]initWithRequest:request delegate:self];
    
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error{
    NSLog(@"did fail");
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"ERROR", nil) message:NSLocalizedString(@"UP FAILED", nil) delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
//    [_progressLabel setAlpha:0.0f];
//    [_progressBar setAlpha:0.0f];
//    [_uploadingView setAlpha:0.0f];
    [_alertUpload dismissWithClickedButtonIndex:0 animated:YES];

}
-(void)connection:(NSURLConnection*)connection didSendBodyData:(NSInteger)bytesWritten totalBytesWritten:(NSInteger)totalBytesWritten totalBytesExpectedToWrite:(NSInteger)totalBytesExpectedToWrite
{
    float a=totalBytesWritten;
    float b=totalBytesExpectedToWrite;
    float temp=a / b ;
    if (temp<0.9) {
        [_progressBar setProgress:temp];
    }
    if (temp==1) {
        [[_alertUpload viewWithTag:[_alertUpload cancelButtonIndex]]setUserInteractionEnabled:NO];
        
    }
    
    
    NSLog(@"%f",temp);
}
-(void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data{
   
    [responseData appendData:data];
}

-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response{
    NSLog(@"did receive response ");
    responseData=[[NSMutableData alloc]init];
  [[_alertUpload viewWithTag:[_alertUpload cancelButtonIndex]]setUserInteractionEnabled:YES];

    
    
}
-(void)connectionDidFinishLoading:(NSURLConnection *)connection{
    

    [_alertUpload dismissWithClickedButtonIndex:0 animated:YES];
    int temporary=[photos count] * 120 +20*([photos count]) ;
    [_scrollView setContentOffset:CGPointMake(temporary,0) animated:YES];
    UIButton*temp=[buttons objectAtIndex:[photos count]];
    NSLog(@"%d",[temp tag]);
    temp.imageView.contentMode = UIViewContentModeCenter;
    
    if (self.actualLoadedPhoto.size.height>self.actualLoadedPhoto.size.width) {
        UIImage*resized=[self imageWithImageScaledToHeight:self.actualLoadedPhoto scaledToHeigth:140];
        [temp setImage:resized forState:UIControlStateNormal];
        [temp setBackgroundImage:nil forState:UIControlStateNormal];
    }
    else
    {
        UIImage*resized=[self imageWithImage:self.actualLoadedPhoto scaledToWidth:120];
        [temp setImage:resized forState:UIControlStateNormal];
        [temp setBackgroundImage:nil forState:UIControlStateNormal];
        
    }
    [photos addObject:self.actualLoadedPhoto];
    NSString *str = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
    Image* newImage=[[Image alloc]init];
    str = [str substringWithRange:NSMakeRange(1, [str length]-2)];
    
    newImage.blobKey=str;
    [restaurant.menuImages addObject:newImage];
    NSLog(@"%@",str);
//    [self appdelegate].isLoadingData=NO;

    [self uploadImage: [self.view viewWithTag:[self.photos count]]];
    
    
}
-(UIImage*)imageWithImage: (UIImage*) sourceImage scaledToWidth: (float) i_width
{
    float oldWidth = sourceImage.size.width;
    float scaleFactor = i_width / oldWidth;
    
    float newHeight = sourceImage.size.height * scaleFactor;
    float newWidth = oldWidth * scaleFactor;
    
    UIGraphicsBeginImageContext(CGSizeMake(newWidth, newHeight));
    [sourceImage drawInRect:CGRectMake(0, 0, newWidth, newHeight)];
    UIImage *newImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    return newImage;
}

-(UIImage*)imageWithImageScaledToHeight: (UIImage*) sourceImage scaledToHeigth: (float) i_height
{
    float oldHeigth = sourceImage.size.height;
    float scaleFactor = i_height / oldHeigth;
    
    float newWidth = sourceImage.size.width * scaleFactor;
    float newHeigth = oldHeigth * scaleFactor;
    
    UIGraphicsBeginImageContext(CGSizeMake(newWidth, newHeigth));
    [sourceImage drawInRect:CGRectMake(0, 0, newWidth, newHeigth)];
    UIImage *newImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    return newImage;
}
-(void) imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info

{
    UIImage *image = [info objectForKey:UIImagePickerControllerOriginalImage];
    
    //
    //edit or upload actions
    //
    CropViewController *cropViewController =[self.storyboard instantiateViewControllerWithIdentifier:@"CropView"];
    cropViewController.delegate = self;
    cropViewController.sourceImage = image;
    [self dismissModalViewControllerAnimated:YES];
    [[self navigationController] pushViewController: cropViewController animated:YES];
    //[self uploadImageWithImage:image];

    
}

- (void)viewDidUnload {
    
    [self setNameOfRestaurant:nil];
    [self setAddressOfRestaurant:nil];
    [self setThumbnail:nil];
    [self setTest:nil];
    [self setNameOfRestaurant:nil];
    [self setAddressOfRestaurant:nil];
    [self setImageViewMainPicture:nil];
    [self setIsProfilePublishedImage:nil];
    [self setIsProfilePublihedText:nil];
    [self setUploadingView:nil];
    [self setProgressBar:nil];
    [self setProgressLabel:nil];
    [super viewDidUnload];
}
- (IBAction)refreshButton:(id)sender {
    //refresh alert    
    [self refreshRestaurant];
    
}
- (IBAction)chengeRestaurantPublishingState:(id)sender {
//    if ([self appdelegate].isLoadingData) {
//        [self showBusyPopup];
//    }
//    else{
        NSString *msgString;
        int publishState = [restaurant.isVisibleForApp intValue];
        
        if (publishState==1)
            msgString = NSLocalizedString(@"CONFIRM_RESTAURANT_UNPUBLISHING", nil);
        else
            msgString = NSLocalizedString(@"CONFIRM_RESTAURANT_PUBLISHING", nil);
        
        
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"CONFIRM", nil)
                                                        message:msgString
                                                       delegate:self
                                              cancelButtonTitle:NSLocalizedString(@"NO",nil)
                                              otherButtonTitles:NSLocalizedString(@"YES",nil), nil];
        alert.tag = 21;
        [alert show];
//    }
}

-(void)changePublishingState{
    NSString*type=restaurant.isVisibleForApp;
    int ok=[type intValue];
    RestaurantVisibilityChanger *manager=[[RestaurantVisibilityChanger alloc]init];
    
    if (ok==1) {
        [_isProfilePublihedText setUserInteractionEnabled:FALSE ];
        [manager setRestaurantInvisibleWitkRestaurantId:restaurant.id];
        
    }
    else{
        [_isProfilePublihedText setUserInteractionEnabled:FALSE ];
        [manager setRestaurantVisibleWitkRestaurantId:restaurant.id];
    }

}

-(void) changeProfileImage: (id)selector{
    if (tempButton) {
        
        [[tempButton layer]setBorderWidth:0.0f];
    }
    UIButton*but=(UIButton*)[_scrollView viewWithTag:restaurant.publishedImageIndex.intValue+1]; //tag of button equals imageIndex+1
    
    if(but)
        [[but layer] setBorderWidth:0.0f];
    [[but layer] setCornerRadius:0.0f];

    
    UIButton*edited=(UIButton*)[selector self];
    
    restaurant.publishedImageIndex = @(edited.tag-1);

    tempButton=edited;
    
    MainPictureChanger *changer=[[MainPictureChanger alloc]init];
    
    Image*temp=[restaurant.menuImages objectAtIndex:edited.tag-1];
    [changer changeProfilePictureWithImageBlob:temp.blobKey andRestaurantId:restaurant.id];
    NSLog(@"ustawione jako glowne %d dla restauracji id=%@", edited.tag, restaurant.id);
    [[edited layer] setBorderColor:[[UIColor greenColor] CGColor]];
    [[edited layer] setBorderWidth:4.0f];
    [[edited layer] setCornerRadius:8.0f];

}

-(void)showLoadingPopUp{
        loading=[[UIAlertView alloc] initWithTitle:NSLocalizedString(@"LOADING", nil)
                                           message:NSLocalizedString(@"DOWNLOADING", nil)
                                          delegate:self
                                 cancelButtonTitle:NSLocalizedString(@"CANCEL", nil)
                                 otherButtonTitles:nil];
        loading.tag = 23;
        [loading show];
                                                               //loading alert
}
@end





